/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll Admin v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APADM-318-FTV
// URL : http://www.phpkobo.com/ajax-poll-admin
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CPnm = function CPnm( cfg )
	{
		this.cfg = cfg;
		this.setup();
	}

	CPnm.prototype = {

		getSectSelector : function( sect )
		{
			return '.pnm-a[sect="' + sect +'"]';
		},

		setupItem : function( sect )
		{
			var jqo = $( "<div class='pnm-item' " +
				"sect='" + sect + "'></div>" );
			jqo.html( this.cfg.menu[sect].label );
			jqo.attr( 'title', this.cfg.menu[sect].title );
			$( '.pnm' ).append( jqo );
		},

		setupHandle : function()
		{
			var jqo = $( "<div class='pnm-handle'>☷☷</div>" );
			$( '.pnm' ).append( jqo );
		},

		setupItems : function()
		{
			$( 'body' ).append( "<div class='pnm'></div>" );

			for ( sect in this.cfg.menu )
			{
				this.setupItem( sect );
			}
			this.setupHandle();
		},

		setupMouseOver : function()
		{
			$( ".pnm-item" ).mouseover( function() {
				$( this ).addClass( "pnm-item-mover" );
			});

			$( ".pnm-item" ).mouseout( function() {
				$( this ).removeClass( "pnm-item-mover" );
			});
		},

		setupMove : function()
		{
			this.jqo_moving = $( ".pnm" );
			this.jqo_handle = $( ".pnm-handle" );

			var _this = this;
			this.jqo_handle.mousedown( function( e ){
				_this.addMouseCapture( e );
			});
		},

		setupAction : function()
		{
			var _this = this;
			$('.pnm-item').click( function( e ){
				var pos = -1;

				var sect = $(this).attr('sect')
				switch( sect )
				{
				case "top":
					pos = 0;
					break;
				case "bottom":
					pos = $(document).height();
					break;
				default:
					var dest = $( _this.getSectSelector(sect) );
					if ( dest.length > 0 )
					{
						pos = dest.offset().top-8;
					}
				}

				if ( pos != -1 )
				{
					$( 'html, body' ).stop().animate({
						scrollTop: pos
					}, 1000,'easeInOutExpo');
				}

				e.preventDefault();
			});
		},

		update : function()
		{
			var _this = this;
			$('.pnm-item').each( function(){
				var b_show = false;

				var sect = $(this).attr('sect');
				switch( sect )
				{
				case "top":
				case "bottom":
					b_show = true;
					break;

				default:
					var dest = $( _this.getSectSelector( sect ) + ":visible" );
					b_show = ( dest.length > 0 );
					break;
				}

				if ( b_show )
				{
					$(this).show();
				}
			});

			$( '.pnm' ).show();
		},

		setup : function()
		{
			if ( $( ".pnm-a" ).length == 0 ) return;
			this.setupItems();
			this.setupMouseOver();
			this.setupMove();
			this.setupAction();
			this.update();
		},

		addMouseCapture : function( e )
		{
			var _this = this;
			var jqo_moving = this.jqo_moving;

			//-- [BEGIN] Mouse Move
			var h_mousemove = function( e )
			{
				e.preventDefault();

				//-- move panel
				jqo_moving.offset({
					"top": e.pageY - _this.rel_pos_y,
					"left": e.pageX - _this.rel_pos_x
				});
			};
			//-- [END] Mouse Move

			//-- [BEGIN] Mouse Up
			var h_mouseup = function( e )
			{
				jqo_moving.css({
					"position": "fixed",
					"top": e.clientY - _this.rel_pos_y,
					"left":  e.clientX - _this.rel_pos_x
				});

				//-- [BEGIN] Release Mouse
				$(document).unbind( "mousemove", h_mousemove );
				$(document).unbind( "mouseup", h_mouseup );
				//-- [END] Release Mouse

				//-- Enable text selection
				document.onselectstart = function(){ return true; }
			};
			//-- [END] Mouse Up

			//-- [BEGIN] Capture Mouse
			$(document).mousemove( h_mousemove );
			$(document).mouseup( h_mouseup );
			//-- [END] Capture Mouse

			//-- [BEGIN] Mouse Down

			//-- Disable text selection
			document.onselectstart = function(){ return false; }

			//-- Fix chrome cursor problem while dragging
			if ( e.originalEvent.preventDefault ) {
				e.originalEvent.preventDefault();
			}

			//-- keep offset in static mode
			var offset = jqo_moving.offset();

			//-- [BEGIN] Shift to Absolute Mode
			this.rel_pos_y = e.pageY - offset.top;
			this.rel_pos_x = e.pageX - offset.left;
			jqo_moving.css({
				"position": "absolute"
			});
			//-- [END] Shift to Absolute Mode

			//-- set offset in absolute mode
			jqo_moving.offset( offset );

			//-- [END] Mouse Down
		}
	};

	$['CPnm'] = CPnm;

}(jQuery));
