<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll Admin v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APADM-318-FTV
// URL : http://www.phpkobo.com/ajax-poll-admin
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

//	include( dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/config.env.inc.php' );
	require( dirname(dirname(dirname(dirname(__FILE__)))) . '/common.inc.php' );
	$sys =& CVSystem::SetupSystem();
	$sys->SetUserType( UT_STAFF );

class CPollEditor
{
	//----------------------------------------------------------------
	function pv( $key )
	//----------------------------------------------------------------
	{
		global $sys;
		$ret = $sys->GetIV( $key );
		if ( is_null( $ret ) )
			$ret = '';
		return $ret;
	}

	//----------------------------------------------------------------
	function addToFv( &$fv )
	//----------------------------------------------------------------
	{
		$fv[] = array( "rlog_edit_date_time", "'" . date("Y-m-d H:i:s") . "'" );
		$fv[] = array( "rlog_edit_user_type", "'S'" );
		$fv[] = array( "rlog_edit_user_id", "'" . $this->user_id . "'" );
		$fv[] = array( "rlog_edit_user_name", "'" . $this->username . "'" );
	}

	//----------------------------------------------------------------
	function getQc( &$db, $poll_id )
	//----------------------------------------------------------------
	{
		$qc = array(
			"poll_id = '" . $db->Sanitize($poll_id) . "'",
		);
		return $qc;
	}

	//----------------------------------------------------------------
	function load( $db, $poll_id )
	//----------------------------------------------------------------
	{
		if ( $poll_id == -1 )
		{
			$settings = array();
			$settings['ver'] = "1.00";
			$settings['title'] = "";
			$settings['options'] = array();
		}
		else
		{
			$table_name = TBL_POLL;
			$ls = array( "poll_id", "settings" );
			$qc = array(
				"poll_id=" . $db->Sanitize($poll_id) . "",
			);
			$sql = $db->GetSQLSelect( $table_name, $ls, $qc ) . " LIMIT 1";
			$result = $db->Query( $sql );
			if ( $rs = $db->GetRowA( $result ) )
			{
				$settings = $rs['settings'];
			}
			$db->FreeResult( $result );

			$settings = json_decode( $settings, true );

			foreach( $settings['options'] as &$option )
			{
				$table_name = TBL_OPTION;
				$ls = array( "cnt" );
				$qc = array(
					"option_id=" . $db->Sanitize( $option['option_id'] ) . "",
				);
				$sql = $db->GetSQLSelect( $table_name, $ls, $qc ) . " LIMIT 1";
				$result = $db->Query( $sql );
				if ( $rs = $db->GetRowA( $result ) )
				{
					$option['cnt'] = $rs['cnt'];
				}
				$db->FreeResult( $result );
			}
		}

		return $settings;
	}

	//----------------------------------------------------------------
	function validate( $settings, &$errmsg )
	//----------------------------------------------------------------
	{
		if ( !empty( $settings['dt_start'] ) ) {
			$b = CValidator::IsDateTime( $settings['dt_start'] ) &&
				( $settings['dt_start'] > 0 );
			if ( !$b )
			{
				$errmsg = "Start : Invalid Date & Time (" .
					$settings['dt_start'] . ")";
				return false;
			}
		}

		if ( !empty( $settings['dt_end'] ) ) {
			$b = CValidator::IsDateTime( $settings['dt_end'] ) &&
				( $settings['dt_end'] > 0 );
			if ( !$b )
			{
				$errmsg = "End : Invalid Date & Time (" .
					$settings['dt_end'] . ")";
				return false;
			}
		}

		if ( trim($settings['title']) == '' )
		{
			$errmsg = "'Poll Title' is required";
			return false;
		}

		if ( trim($settings['skin_type']) == '' )
		{
			$errmsg = "Please select 'Skin'";
			return false;
		}

		$b = CValidator::isInteger( $settings['tip_box_duration'] ) &&
			( $settings['tip_box_duration'] > 0 );
		if ( !$b )
		{
			$errmsg = "Time delay on tool tips : Invalid number (" .
				$settings['tip_box_duration'] . ")";
			return false;
		}

		$b = CValidator::isInteger( $settings['caption_width'] ) &&
			( $settings['caption_width'] > 0 );
		if ( !$b )
		{
			$errmsg = "Caption Width : Invalid number (" .
				$settings['caption_width'] . ")";
			return false;
		}

		foreach( $settings['options'] as $option )
		{
			$b = CValidator::isInteger( $option['cnt'] ) &&
				( $option['cnt'] >= -1 );
			if ( !$b )
			{
				$errmsg = "Vote Count : Invalid number (" .
					$option['cnt'] . ")";
				return false;
			}
		}

		return true;
	}

	//----------------------------------------------------------------
	function save( $db, $poll_id, $settings )
	//----------------------------------------------------------------
	{

		//-- create poll record if not exits
		if ( $poll_id == -1 )
		{
			$table_name = TBL_POLL;
			$fv = array(
				array( "title", "'" . $db->Sanitize($settings['title']) . "'" )
			);
			$fv[] = array( "active", "'Y'" );
			$fv[] = array( "rlog_create_date_time", "'" . date("Y-m-d H:i:s") . "'" );
			$fv[] = array( "rlog_create_user_type", "'S'" );
			$fv[] = array( "rlog_create_user_id", "'" . $this->user_id . "'" );
			$fv[] = array( "rlog_create_user_name", "'" . $this->username . "'" );
			$poll_id = $db->InsertRecord( $table_name, $fv );
		}

		//-- $options_ids_from_db
		$options_ids_from_db = array();

		$table_name = TBL_OPTION;
		$ls = array( "option_id" );
		$qc = array(
			"poll_id=" . $db->Sanitize($poll_id) . "",
		);
		$sql = $db->GetSQLSelect( $table_name, $ls, $qc );
		$result = $db->Query( $sql );
		while ( $rs = $db->GetRowA( $result ) )
		{
			$options_ids_from_db[] = $rs['option_id'];
		}
		$db->FreeResult( $result );

		//-- update, delete, insert options
		$options =& $settings['options'];
		foreach( $options_ids_from_db as $option_id )
		{
			$b_found = false;
			foreach( $options as &$option )
			{
				if ( $option['option_id'] == $option_id )
				{
					$option['b_found'] = true;
					$b_found = true;
					break;
				}
			}

			if ( $b_found )
			{
				if ( $option['cnt'] != -1 )
				{// UPDATE
					$table_name = TBL_OPTION;
					$fv = array(
						array( "cnt", "'" . $db->Sanitize($option['cnt']) . "'" )
					);
					$qc = array(
						"option_id = '" . $db->Sanitize($option_id) . "'",
					);
					$db->UpdateRecord( $table_name, $fv, $qc );
				}
			}
			else
			{// DELETE
				$table_name = TBL_OPTION;
				$qc = array(
					"option_id=" . $db->Sanitize($option_id)
				);
				$db->DeleteRecord( $table_name, $qc );
			}
		}

		foreach( $options as &$option )
		{// INSERT
			if ( !isset( $option['b_found'] ) )
			{
				$table_name = TBL_OPTION;
				$fv = array(
					array( "poll_id", sprintf( "%d", $poll_id ) ),
					array( "cnt", sprintf( "%d", $option['cnt'] ) ),
				);
				$option['option_id'] = $db->InsertRecord( $table_name, $fv );
			}
		}

		//-- clean up $options
		foreach( $options as &$option )
		{
			if ( isset($option['b_found']) )
			{
				unset( $option['b_found'] );
			}
			unset( $option['cnt'] );
		}

		//-- update poll record

		//-- save settings
		$title = $settings['title'];
		$active = $settings['active'];
		$settings = json_encode( $settings );

		$table_name = TBL_POLL;
		$fv = array(
			array( "active", "'" . $db->Sanitize($active) . "'" ),
			array( "title", "'" . $db->Sanitize($title) . "'" ),
			array( "settings", "'" . $db->Sanitize($settings) . "'" ),
		);
		$this->addToFv( $fv );
		$qc = array(
			"poll_id = '" . $db->Sanitize($poll_id) . "'",
		);
		$db->UpdateRecord( $table_name, $fv, $qc );

		return $poll_id;
	}

	//----------------------------------------------------------------
	function run()
	//----------------------------------------------------------------
	{
		global $sys;
		$this->user_id = $sys->AuthSession->GetV( "staff_id" );
		if ( empty( $this->user_id ) )
		{
			$res['result'] = 'Time Out : Please log in again';
		}
		else
		{
			$this->group_id = $sys->AuthSession->GetV( "group_id" );
			$this->username = $sys->AuthSession->GetV( "username" );
			$this->b_admin = ( $this->group_id == GROUP_ADMIN );

			$db =& $sys->DB;

			$poll_id = $this->pv( 'poll_id' );

			$res = array();
			$cmd = $this->pv( 'cmd' );
			switch ( $cmd )
			{
			case "load":
				$poll_id = $this->pv( 'poll_id' );

				$res['settings'] = $this->load( $db, $poll_id );
				$res['cmd'] = $cmd;
				$res['result'] = 'OK';
				break;

			case "save":
				$res['cmd'] = $cmd;

				$poll_id = $this->pv( 'poll_id' );
				$settings = $this->pv( 'settings' );
				$settings = json_decode( $settings, true );

				if ( $this->validate( $settings, $errmsg ) )
				{
					$poll_id = $this->save( $db, $poll_id, $settings );
					$res['poll_id'] = $poll_id;
					$res['result'] = 'OK';
				}
				else
				{
					$res['result'] = $errmsg;
				}
				break;

			default:
				$res['result'] = 'Invalid Command';
				break;
			}
		}

		echo json_encode( $res );
	}
}

$obj = new CPollEditor();
$obj->run();

?>