/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll Admin v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APADM-318-FTV
// URL : http://www.phpkobo.com/ajax-poll-admin
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	//----------------------------------------------------------------
	function CAutoScroll()
	//----------------------------------------------------------------
	{
		this.y_coef = 0.2;
		this.speed_ms = 10;
		this.y_activate = 60;//pixcel
		this.y_deactivate = this.y_activate * 2;//pixcel
	}

	CAutoScroll.prototype = {

		init : function( jqo_moving_panel )
		{
			this.speed = 0;
			this.timer_id = null;
			this.jqo_moving_panel = jqo_moving_panel;
		},

		done : function()
		{
			if ( this.timer_id != null )
			{
				clearInterval( this.timer_id );
				this.timer_id = null;
			}
		},

		mouseMove : function( pageX, pageY )
		{
			this.pageX = pageX;
			this.pageY = pageY;

			if ( this.speed == 0 )
			{
				this.checkStatus();
				if ( this.speed != 0 )
				{
					var _this = this;
					this.timer_id = setInterval(
						function(){ _this.scroll(); },
						this.speed_ms );
				}
			}
			else
			{
				this.checkStatus();
				if ( this.speed == 0 )
				{
					this.done();
				}
			}
		},

		scroll : function()
		{
			var dy = this.speed * this.y_coef;
			window.scrollBy( 0, dy );
			this.jqo_moving_panel.css( 'top',
				this.jqo_moving_panel.offset().top + dy );
		},

		checkStatus : function()
		{
			var screen_top = $(window).scrollTop();
			var screen_height = $(window).height();
			var d;

			d = ( this.pageY - screen_top ) - this.y_activate;
			if ( d < 0 )
			{
				this.speed = d;
				return;
			}

			d = this.y_activate - ( ( screen_top + screen_height ) - this.pageY );
			if ( d > 0 )
			{
				this.speed = d;
				return;
			}

			d = this.pageY - screen_top - this.y_deactivate;
			if ( d > 0 )
			{
				this.speed = 0;
				return;
			}

			d = ( this.y_deactivate - ( ( screen_top + screen_height ) - this.pageY ) )
			if ( d < 0 )
			{
				this.speed = 0;
				return;
			}
		}
	}

	//----------------------------------------------------------------
	function CPanel( attr )
	//----------------------------------------------------------------
	{
		this.attr = attr;
	}

	CPanel.prototype = {

		getBoard : function()
		{
			return this.prt.getBoard();
		},

		onAttached : function( pos )
		{

			var _this = this;
			var board = this.getBoard();

			this.jqo = $( "#" + board.attr.id_tpl_panel + " .panel" ).eq(0).clone( true );
			this.jqo.data( 'jso', this );
			var jqo = this.jqo;
			jqo.attr( 'id', board.getNewPanelID() );

			//-- [BEGIN] Delete
			jqo.find( ".panel-btn-delete" ).eq(0).click( function(e) {
				e.preventDefault();
				if ( _this.client.onCanClose() ) {
					_this.onDelete();
				}
			}).keydown( function(e) {
				if ( e.keyCode == 13 ) {
					$(this).trigger( "click" );
				}
			}).mousedown( function( e ) {
				e.stopImmediatePropagation();
			});
			//-- [END] Delete

			//-- [BEGIN] Add New
			jqo.find( ".panel-btn-addnew" ).eq(0).click( function(e) {
				e.preventDefault();
				_this.onAddNew();
			}).keydown( function(e) {
				if ( e.keyCode == 13 ) {
					$(this).trigger( "click" );
				}
			});
			//-- [END] Add New

			jqo.find('.panel-handle').mousedown( function( e ) {
				board.addMouseCapture( e, _this );
			});

			if ( pos === 'first' )
			{
				board.jqo_list.prepend( jqo );
			}
			else if ( pos === 'last' )
			{
				board.jqo_list.append( jqo );
			}
			else
			{
				pos.jqo.after( jqo );
			}

			jqo.css({ opacity: 0 });
			jqo.animate({
				opacity: 1.0,
				height: 'toggle'
			}, board.duration_show_panel, function() {
				jqo.fadeIn();
				_this.client = new $[board.attr.class_client]();
				_this.client.init( jqo.find( '.panel-clientarea' ).eq(0), _this.attr );
			});
		},

		onDelete : function()
		{
			var board = this.getBoard();
			var jqo = this.jqo;

			jqo.css({ backgroundColor:"#ff8080" });
			jqo.animate({
				opacity: 0.0,
				height: 'toggle'
			}, board.duration_hide_period, function() {
				jqo.jso = null;
				jqo.remove();
			});
		},

		onAddNew : function() {
			var board = this.getBoard();
			board.addNew( this );
		},

		getJsonData : function()
		{
			return this.client.getJsonData();
		},

		putJsonData : function( json )
		{
			this.client.putJsonData( json );
		}
	}

	//----------------------------------------------------------------
	function CListBoard( attr )
	//----------------------------------------------------------------
	{
		this.attr = attr;
		//this.b_mouse_capture = false;
	}

	CListBoard.prototype = {

		getBoard : function()
		{
			return this;
		},

		addChild : function( child, pos )
		{
			child.prt = this;
			child.sys = this.sys;
			child.onAttached( pos );
			return child;
		},

		addNew : function( pos )
		{
			return this.addChild( new CPanel( null ), pos );
		},

		getNewPanelID : function ()
		{
			var s = this.jqo_list.attr('id') + '-panel-' + this.id_idx.toString();
			this.id_idx++;
			return s;
		},

		cloneIDSafe : function( org_obj, new_id )
		{//-- clone object with ID ( for IE bug )
			var org_id = org_obj.attr('id');
			org_obj.attr( 'id', 'id_temporary' );
			var new_obj = org_obj.clone();
			new_obj.attr( 'id', new_id );
			org_obj.attr( 'id', org_id );
			return new_obj;
		},

		onAttached : function()
		{
			var _this= this;

			this.id_idx = 1;
			this.rel_pos_x = 0;
			this.rel_pos_y = 0;
			this.id_moving_panel = undefined;
			this.duration_show_panel = 100;
			this.duration_hide_panel = 200;

			//-- frame
			this.jqo_frame = $( "#" + this.attr.id_board );

			//-- header
			this.jqo_header = $( "#" + this.attr.id_tpl_panel + " .header" ).eq(0).clone();

			//-- header:addnew
			this.jqo_header.find('.panel-btn-addnew').click( function(e) {
				e.preventDefault();
				_this.addNew( "first" );
			}).keydown( function(e) {
				if ( e.keyCode == 13 ) {
					$(this).trigger( "click" );
				}
			});
			//-- header:delete
			this.jqo_header.find('.panel-btn-delete').click( function(e) {
				e.preventDefault();
				_this.onDeleteChecked();
			}).keydown( function(e) {
				if ( e.keyCode == 13 ) {
					$(this).trigger( "click" );
				}
			});
			//-- header:checkbox
			var cb = this.jqo_header.find('.panel-cb-select');
			cb.click( function() {
				_this.jqo_list.find('.panel-cb-select')
					.prop( 'checked', cb.is(':checked') );
			});

			//-- header:append
			this.jqo_frame.append( this.jqo_header );
			this.jqo_header.show();

			//-- list
			this.jqo_list = $( "<div id='" + this.attr.id_board + "-list'></div>" );
			this.jqo_frame.append( this.jqo_list );

			this.autoscroll = new CAutoScroll();
		},

		onDeleteChecked : function()
		{
			var total = 0;
			this.jqo_list.find( '.panel' ).each( function(){
				var checkbox = $(this).find( '.panel-cb-select' );
				if ( checkbox.is(':checked') )
				{
					total++;
				}
			});

			if ( total == 0 )
			{
				alert( 'Please select at least one checkbox.' );
			}
			else
			{
				if ( confirm( "You are about to delete " + total + " option(s). Proceed?" ) )
				{
					this.jqo_list.find( '.panel' ).each( function(){
						var checkbox = $(this).find( '.panel-cb-select' );
						if ( checkbox.is(':checked') )
						{
							$(this).data( 'jso' ).onDelete();
						}
					});
				}
			}
		},

		getJsonData : function()
		{
			var rx = [];
			this.jqo_list.find( '.panel' ).each( function(){
				var json = $(this).data( 'jso' ).getJsonData();
				if ( json !== false )
				{
					rx.push( json );
				}
			});

			return rx;
		},

		putJsonData : function( json )
		{
			var tmp = this.duration_show_panel;
			this.duration_show_panel = 0;

			for( var i = 0; i < json.length; i++ )
			{
				this.addChild( new CPanel( json[i] ), "last" );
			}

			this.duration_show_panel = tmp;
		},

		addMouseCapture : function( e, panel )
		{
			var board = this;

			if (e.which != 1) return false; 
			//if ( board.b_mouse_capture ) return;
			//board.b_mouse_capture = true;

			e.preventDefault();

			//-- [BEGIN] Mouse Move
			var h_mousemove = function( e )
			{
				e.preventDefault();

				//-- get moving panel
				if ( board.id_moving_panel == undefined ) return;
				var jqo_moving_panel = $( '#' + board.id_moving_panel );

				//-- auto scroll
				board.autoscroll.mouseMove( e.pageX, e.pageY );

				//-- move panel
				jqo_moving_panel.offset({
					"top": e.pageY - board.rel_pos_y,
					"left": jqo_moving_panel.offset().left
				});

				//-- move space panel
				var pos_y = board.jqo_list.offset().top;
				var y = e.pageY - pos_y - board.rel_pos_y;
				var yh = y + jqo_moving_panel.height();

				var pdiv = 3;
				if ( y < board.jqo_space_panel.offset().top - pos_y )
				{
					board.jqo_list.children().each( function( idx ) {
						var jqo = $(this);
						if ( jqo.attr('id') == board.jqo_space_panel.attr('id') )
						{
							return false;
						}
						else if ( jqo.attr('id') != board.id_moving_panel )
						{
							var h = jqo.height();
							var y1 = jqo.offset().top - board.jqo_list.offset().top;
							if ( y < y1+h*1/pdiv )
							{
								jqo.before( board.jqo_space_panel );
								return false;
							}
						}
					});
				}
				else
				{
					$.each( board.jqo_list.children().get().reverse(), function( idx ) {
						var jqo = $(this);
						if ( jqo.attr('id') == board.jqo_space_panel.attr('id') )
						{
							return false;
						}
						else if ( jqo.attr('id') != board.id_moving_panel )
						{
							var h = jqo.height();
							var y1 = jqo.offset().top - board.jqo_list.offset().top;
							if ( yh > y1+h*(pdiv-1)/pdiv )
							{
								jqo.after( board.jqo_space_panel );
								return false;
							}
						}
					});
				}
			};
			//-- [END] Mouse Move

			//-- [BEGIN] Mouse Up
			var h_mouseup = function( e )
			{
				if (e.which != 1) return false; 
				//board.b_mouse_capture = false;

				e.preventDefault();

				if ( board.id_moving_panel == undefined ) return;
				var jqo_moving_panel = $( '#' + board.id_moving_panel );
				jqo_moving_panel.css( 'position', 'static' );
				jqo_moving_panel.css( 'z-index', 1 );
				jqo_moving_panel.css( 'opacity', 1.0 );

				jqo_moving_panel.css( 'width', '100%' );

				board.jqo_space_panel.before( jqo_moving_panel );
				board.jqo_space_panel.remove();
				board.id_moving_panel = undefined;

				//-- [BEGIN] Release Mouse
				$(document).unbind( "mousemove", h_mousemove );
				$(document).unbind( "mouseup", h_mouseup );
				//-- [END] Release Mouse

				//-- Enable text selection
				document.onselectstart = function(){ return true; }

				//-- Disable autoscroll
				board.autoscroll.done();
			};
			//-- [END] Mouse Up

			//-- [BEGIN] Capture Mouse
			$(document).mousemove( h_mousemove );
			$(document).mouseup( h_mouseup );
			//-- [END] Capture Mouse

			//-- [BEGIN] Mouse Down

			//-- init autoscroll
			board.autoscroll.init( panel.jqo );

			//-- Disable text selection
			document.onselectstart = function(){ return false; }

			//-- Fix chrome cursor problem while dragging
			if ( e.originalEvent.preventDefault ) {
				e.originalEvent.preventDefault();
			}

			//-- calc y position

			//-- setup a dummy panel
			board.jqo_space_panel = board.cloneIDSafe(
				panel.jqo,
				board.jqo_list.attr('id') + '-space'
			);
			board.jqo_space_panel.html( '' );
			board.jqo_space_panel.css( 'background-color', '#f0f0f0' );
			board.jqo_space_panel.css( 'height', panel.jqo.height() );

			board.jqo_space_panel.css( 'width', panel.jqo.outerWidth(false) );

			board.jqo_space_panel.css( 'z-index', 1 );
			panel.jqo.after( board.jqo_space_panel );

			//-- keep offset in static mode
			var offset = panel.jqo.offset();

			//-- [BEGIN] Shift to Absolute Mode
			var w = panel.jqo.outerWidth(false);

			board.rel_pos_y = e.pageY - offset.top;
			panel.jqo.css( 'position', 'absolute' );
			panel.jqo.css( 'z-index', 10000 );

			panel.jqo.css( 'width', w );


			board.id_moving_panel = panel.jqo.attr('id');

			//-- [END] Shift to Absolute Mode

			//-- set offset in absolute mode
			panel.jqo.offset( offset );

			//-- semi-transparent
			panel.jqo.css( 'opacity', 0.5 );

			//-- [END] Mouse Down
		}
	}

	$.CListBoard = CListBoard;

}(jQuery));
