<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll Admin v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APADM-318-FTV
// URL : http://www.phpkobo.com/ajax-poll-admin
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

include( dirname(__FILE__) . '/include/common.inc.php' );

//----------------------------------------------------------------
// CTClassApp
//----------------------------------------------------------------
class CTClassApp extends CTClassObject
{
	//----------------------------------------------------------------
	// setup
	//----------------------------------------------------------------
	function setup( $sys )
	{
		parent::setup( $sys );

		//-- user tclass as poll_id
		$this->poll_id = $this->sys->tid;

		//-- setup config
		$this->config = array();
		$this->setupConfig( $this->config );

		//-- loadSettings
		switch ( $this->loadSettings() )
		{
		case -1: //not found
			$this->showErrorMsg( "Invalid Poll ID (tid) [{$this->poll_id}]" );
			return false;
		case -2: // inactive
			return false;
		}

		//-- setup poll & poll items
		$this->poll = new CPoll();
		$this->poll->setup( $sys, $this, $this->poll_id );

		//-- settings to poll->attr
		foreach( $this->settings as $key => $val )
		{
			$this->poll->attr( $key, $val );
		}

		//-- load global poll attribute
		$skin = $this->poll->attr( 'skin_type' );
		$path = dirname($this->sys->path_app_root) . "/skins/config.global.inc.php";
		$poll = $this->poll;
		include($path);

		//-- iv to poll->attr
		foreach( $this->sys->iv_buffer as $key => $val )
		{
			$this->poll->attr( $key, $val );
		}

		//-- show "Clear IP & Cookie Block" button
		$this->poll->attr(
			'b_in_admin_panel',
			(
				( $this->isLoggedIn() ) && 
				( $this->poll->tprop('b_admin') == 'Y' )
			)
		);

		//-- input type
		$this->poll->attr( 'vote-input', 
			( $this->poll->attr('multiple') == 'Y' )
			? 'checkbox':'radio' );

		//-- enable-cookie-block
		$this->poll->attr( 'enable-cookie-block', 
			( $this->poll->attr('enable_cookie_block') == 'Y' ));

		//-- enable-ipblock
		$this->poll->attr( 'enable-ip-block', 
			( $this->poll->attr('enable_ip_block') == 'Y' ));

		//-- b-reset-block
		$this->poll->attr( 'b-reset-block', 
			( $this->poll->attr('b_reset_block') == 'Y' ));

		//-- tip-box-duration
		$this->poll->attr( 'tip-box-duration', 
			$this->poll->attr('tip_box_duration') );

		//-- from config file
		$skin = $this->poll->attr( 'skin_type' );
		$path = dirname($this->sys->path_app_root) . "/skins/{$skin}/";
		$poll = $this->poll;
		if ( file_exists($path . "config.inc.php") ) {
			include($path . "config.inc.php");
		}

		//-- Cookie Block
		$name = $this->getCookieBlockName();
		$this->ckblock = new CCookieBlock();
		$this->ckblock->setup( $name );

		//-- cmdpsec
		$this->cmdspec = array();
		$this->setupCmdSpec( $this->cmdspec );

		return true;
	}

	//----------------------------------------------------------------
	// isLoggedIn
	//----------------------------------------------------------------
	function isLoggedIn()
	{
		$sig = "AuthSessionKey:(" . PATH_CONFIG . ")";
		return ( isset( $_SESSION[$sig] ) && ( $_SESSION[$sig] == $sig ));
	}

	//----------------------------------------------------------------
	// setupConfig
	//----------------------------------------------------------------
	function setupConfig( &$config )
	{
		$config['cookie-block-period'] = COOKIE_BLOCK_PERIOD;
	}

	//----------------------------------------------------------------
	// loadSettings
	//----------------------------------------------------------------
	function loadSettings()
	{
		$db = $this->sys->db;
		$poll_id = $this->poll_id;

		//-- get settings
		$table_name = TBL_POLL;
		$ls = array( "poll_id", "active", "settings" );
		$qc = array(
			"poll_id=" . $db->Sanitize($poll_id) . "",
		);
		$sql = $db->GetSQLSelect( $table_name, $ls, $qc ) . " LIMIT 1";
		$result = $db->Query( $sql );
		$settings = null;
		if ( $rs = $db->GetRowA( $result ) )
		{
			$settings = $rs['settings'];
			$active = $rs['active'];
		}
		$db->FreeResult( $result );

		if ( is_null($settings) )
		{
			//-- not found
			return -1;
		}

		if ( $active != 'Y' )
		{
			//-- not active
			return -2;
		}

		$this->settings = json_decode( $settings, true );

		//-- return OK
		return 1;
	}

	function checkCkBlock( $name = null ) {
		if ( $this->poll->attr( "enable-cookie-block" ) ) {
			if ( is_null( $name ) ) {
				return $this->ckblock->exists();
			} else {
				if ( $this->ckblock->exists() ) {
					return in_array( $name,
						explode( "\t", $this->ckblock->get() ) );
				} else {
					return false;
				}
			}
		} else {
			return false;
		}
	}

	//----------------------------------------------------------------
	// setupCmdSpec
	//----------------------------------------------------------------
	function setupCmdSpec( &$cmdspec )
	{
		$skin = $this->poll->attr( 'skin_type' );
		$path = dirname($this->sys->path_app_root) . "/skins/{$skin}/";
		$path_js = $this->sys->path_app_root . "/app/";

		if ( $this->poll->ended() ) {
			$cmdspec["init"] = "result";
		} else {
			$cmdspec["init"] = "front";
		}
		if ( isset($_REQUEST['mode']) && ($_REQUEST['mode']=='result')){
			$cmdspec["init"] = "result";
		}

		$cmdspec["front"] = array(
			"@hd_front",
			"{$path}tpl.front.inc.php",
			"{$path_js}js.front.inc.php",
		);

		$cmdspec["result"] = array(
			"@hd_result",
			"{$path}tpl.result.inc.php",
			"{$path_js}js.result.inc.php",
		);

		$cmdspec["vote"] = array(
			"@hd_vote",
			"{$path}tpl.result.inc.php",
			"{$path_js}js.result.inc.php",
		);

		$cmdspec["clear_block"] = array(
			"@hd_clear_block",
		);
	}

	//----------------------------------------------------------------
	// addStyle
	//----------------------------------------------------------------
	function addStyle( $style )
	{
		$skin = $this->poll->attr( 'skin_type' );
		$style = str_replace( "%tclass%", $skin, $style );
		$style = str_replace( "\r", "\\r", $style );
		$style = str_replace( "\n", "\\n", $style );
		$style = str_replace( "\"", "\\\"", $style );
		$s = "";
		$s .= "<script>(function(\$){";
		$s .= "\$('head').append( \"{$style}\" );";
		$s .= "}(jQuery));</script>";
		echo $s;
	}

	//----------------------------------------------------------------
	// getCookieBlockName
	//----------------------------------------------------------------
	function getCookieBlockName()
	{
		return "ajax-poll-admin-" . sprintf( "%s", $this->poll_id ) . "-cookie-block";
	}

	//----------------------------------------------------------------
	// hd_front
	//----------------------------------------------------------------
	function hd_front( &$ret )
	{
		$this->poll->load();
		return true;
	}

	//----------------------------------------------------------------
	// hd_result
	//----------------------------------------------------------------
	function hd_result( &$ret )
	{
		$this->poll->load();
		$this->poll->calcStats();

		return true;
	}

	//----------------------------------------------------------------
	// hd_vote
	//----------------------------------------------------------------
	function hd_vote( &$ret )
	{
		if ( !$this->poll->started() || $this->poll->ended() ) {
			$ret["msg"] = array( "cmd" => "front" );
			return true;
		}

		//-- IP Block
		if ( $this->poll->attr( "enable-ip-block" ) ) {
			$ipblock = new CIPBlock();
			$ipblock->setup( $this->sys->db, $this->poll_id );
			if ( !$ipblock->validate() )
			{
				$ret["cmd"] = "none";
				$ret["msg"] = array( "cmd" => "already_voted" );
				return false;
			}
		}

		//-- Cookie Block
		if ( $this->poll->attr( "enable-cookie-block" ) ) {
			$cookie_name = $this->getCookieBlockName();
			$cookie_block = new CCookieBlock();
			$cookie_block->setup( $cookie_name,
				$this->config['cookie-block-period'] );
			if ( !$cookie_block->validate() )
			{
				$ret["cmd"] = "none";
				$ret["msg"] = array( "cmd" => "already_voted" );
				return false;
			}
		}

		//-- Load Data
		$this->poll->load(true);
		$this->poll->calcStats();

		//-- store choice in cookie
		if ( isset( $cookie_block ) ) {
			$answer = isset( $_REQUEST['answer'] ) ? $_REQUEST['answer'] : "";
			$answer = json_decode( $answer, true );
			$val = implode( "\t", $answer );
			$cookie_block->add( $val );
		}

		$ret["msg"] = array( "cmd" => "thank_you" );
		return true;
	}

	//----------------------------------------------------------------
	// hd_clear_block
	//----------------------------------------------------------------
	function hd_clear_block( &$ret )
	{
		$ret["cmd"] = "alert";

		//-- IP Block
		$ipblock = new CIPBlock();
		$ipblock->setup( $this->sys->db, $this->poll_id );
		if ( $this->poll->attr( "b-reset-block" ) && $ipblock->clear() )
		{
			echo "IP block was cleared!\r\n";
		}
		else
		{
			echo "Can not clear IP block\r\n";
		}

		//-- Cookie Block
		$cookie_name = $this->getCookieBlockName();
		$cookie_block = new CCookieBlock();
		$cookie_block->setup( $cookie_name,
			$this->config['cookie-block-period'] );
		if ( $this->poll->attr( "b-reset-block" ) && $cookie_block->clear() )
		{
			echo "Cookie block was cleared!\r\n";
		}
		else
		{
			echo "Can not clear Cookie block\r\n";
		}

		return true;
	}
}

?>