<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll Admin v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APADM-318-FTV
// URL : http://www.phpkobo.com/ajax-poll-admin
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

define( 'APP_CLASS_TAG', 'tclass' );
define( 'APP_ID_TAG', 'tid' );

//----------------------------------------------------------------
// CTClassSys
//----------------------------------------------------------------
class CTClassSys
{
	//----------------------------------------------------------------
	// fatalError
	//----------------------------------------------------------------
	function fatalError( $msg )
	{
		$json = array( "result" => $msg );
		echo CJson::encode( $json );
		exit;
	}

	//----------------------------------------------------------------
	// setupIV
	//----------------------------------------------------------------
	function setupIV()
	{
		//-- Reverse magic_quote effect
		if ( function_exists("get_magic_quotes_gpc")&&get_magic_quotes_gpc() )
		{
			function stripslashes_deep($value)
			{
				$value = is_array($value) ?
					array_map('stripslashes_deep', $value) :
					stripslashes($value);
				return $value;
			}

			$_POST = array_map('stripslashes_deep', $_POST);
			$_GET = array_map('stripslashes_deep', $_GET);
			$_COOKIE = array_map('stripslashes_deep', $_COOKIE);
			$_REQUEST = array_map('stripslashes_deep', $_REQUEST);
		}

		$this->iv_buffer = array();
		foreach ( $_REQUEST as $key => $val )
		{
			$this->iv_buffer[$key] = $val;
		}
	}

	//----------------------------------------------------------------
	// iv
	//----------------------------------------------------------------
	function iv( $key )
	{
		if ( !isset( $this->iv_buffer[ $key ] ) ) { return ''; }
		return $this->iv_buffer[ $key ];
	}

	//----------------------------------------------------------------
	// getThisPageURL
	//----------------------------------------------------------------
	function getThisPageURL()
	{
		$pageURL = 'http';

		if (( isset($_SERVER["HTTPS"]) ) && ( $_SERVER["HTTPS"] == "on" ))
		{
			$pageURL .= "s";
		}
		$pageURL .= "://" . $_SERVER["SERVER_NAME"];

		if ($_SERVER["SERVER_PORT"] != "80")
		{
			$pageURL .= ":" . $_SERVER["SERVER_PORT"];
		}

		$pageURL .= $_SERVER['SCRIPT_NAME'];

		return $pageURL;
	}

	//----------------------------------------------------------------
	// checkPhpVersion
	//----------------------------------------------------------------
	function checkPhpVersion()
	{
		$ver_req = "5.2";
		$ver_cur = phpversion();
		if ( strnatcmp( $ver_cur, $ver_req ) >= 0 )
		{ 
			# equal or newer 
		} 
		else 
		{ 
			$msg = '';
			$msg .= "This script requires PHP v{$ver_req} or later.\r\n";
			$msg .= "Unfortunately, your PHP version is {$ver_cur}.\r\n";
			$msg .= "Please upgrade your PHP and try again!";
			$this->fatalError( $msg );
		}
	}

	//----------------------------------------------------------------
	// checkMbString()
	//----------------------------------------------------------------
	function checkMbString()
	{
		if ( !function_exists( 'mb_strlen' ) )
		{ 
			$msg = '';
			$msg .= "This script requires Multibyte Support (mbstring) extension.\r\n";
			$msg .= "Unfortunately, it's not installed in your PHP.\r\n";
			$msg .= "Please install it and try again!";
			$this->fatalError( $msg );
		}
	}

	//----------------------------------------------------------------
	// checkRequirement()
	//----------------------------------------------------------------
	function checkRequirement()
	{
		$this->checkPhpVersion();
		$this->checkMbString();
	}

	//----------------------------------------------------------------
	// sanitizeFilename
	//----------------------------------------------------------------
	static function sanitizeFilename( $str )
	{
		$str = substr( $str, 0, 255 );

		$res = '';
		$len = strlen( $str );
		for( $i = 0; $i < $len; $i++ )
		{
			$ch = mb_substr( $str, $i, 1 );
			if (
				ctype_alnum( $ch ) ||
				( $ch == '_' ) ||
				( $ch == '-' )
			)
			{
				$res .= $ch;
			}
			else
			{
				$res .= '-';
			}
		}
		return $res;
	}

	//----------------------------------------------------------------
	// run
	//----------------------------------------------------------------
	function run()
	{
		//-- path
		$this->path_app_root = PATH_APP_ROOT;

		//-- url
		$this->url_app_entry = $this->getThisPageURL();
		if ( defined( 'URL_APP_ROOT' ) )
			$this->url_app_root = URL_APP_ROOT;
		else
			$this->url_app_root = dirname($this->url_app_entry) . '/';
		$this->url_app_img = $this->url_app_root . FOLDER_APP_IMG . '/';

		//-- js params
		$this->app_object_selector = APP_OBJECT_SELECTOR;
		$this->app_init_cmd = APP_INIT_CMD;

		//-- setup iv
		$this->setupIV();

		//-- run
		if ( $this->iv( 'cmd' ) != '' )
		{
			//-- requirements
			$this->checkRequirement();

			//-- tclass name
			if ( $this->iv( APP_CLASS_TAG ) != '' )
			{
				$this->tclass = $this->sanitizeFilename( $this->iv( APP_CLASS_TAG ) );
			}
			else
			{
				$this->tclass = APP_DEFAULT_TCLASS;
			}

			//-- tid name
			if ( $this->iv( APP_ID_TAG ) != '' )
			{
				$this->tid = intval( $this->iv( APP_ID_TAG ) );
			}
			else
			{
				$this->tid = APP_DEFAULT_TID;
			}

			//-- tclass path
			$this->path_tclass = $this->path_app_root . $this->tclass . "/"; 

			//-- include tclass config
			$this->path_tclass_config = $this->path_tclass . 'config/common.inc.php';
			if ( !file_exists( $this->path_tclass_config ) )
			{
				$this->fatalError(
					"tclass config file ({$this->tclass}/config.inc.php) " .
					"does not exist" );
			}
			include( $this->path_tclass_config );

			//-- session
			session_name("MYSESSID");
			@session_start();

			//-- MySQL
			$this->db = new CMySQL();
			$this->db->Setup();

			//-- load CTClassApp
			include( $this->path_tclass . 'index.inc.php' );

			//-- start-up
			$obj = new CTClassApp();
			$obj->run( $this );

			//-- MySQL
			$this->db->Close();
		}
		else
		{
			header('Content-Type: application/javascript');
			include( dirname(__FILE__) . '/tclass.js.inc.php' );
		}
	}
}

$sys = new CTClassSys();
$sys->run();

?>